



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>洛谷 P1546 最短网络 Agri-Net Label：Water最小生成树</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">洛谷 P1546 最短网络 Agri-Net Label：Water最小生成树</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-17 05:39:57 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>题目背景</h2>
<p>农民约翰被选为他们镇的镇长！他其中一个竞选承诺就是在镇上建立起互联网，并连接到所有的农场。当然，他需要你的帮助。</p>
<h2>题目描述</h2>
<p>约翰已经给他的农场安排了一条高速的网络线路，他想把这条线路共享给其他农场。为了用最小的消费，他想铺设最短的光纤去连接所有的农场。</p>
<p>你将得到一份各农场之间连接费用的列表，你必须找出能连接所有农场并所用光纤最短的方案。每两个农场间的距离不会超过100000</p>
<h2>输入输出格式</h2>
<p>输入格式：</p>
<p>第一行： 农场的个数，N（3&lt;=N&lt;=100）。</p>
<p>第二行..结尾: 后来的行包含了一个N*N的矩阵,表示每个农场之间的距离。理论上，他们是N行，每行由N个用空格分隔的数组成，实际上，他们限制在80个字符，因此，某些行会紧接着另一些行。当然，对角线将会是0，因为不会有线路从第i个农场到它本身。</p>
<p>输出格式：</p>
<p>只有一个输出，其中包含连接到每个农场的光纤的最小长度。</p>
<h2>输入输出样例</h2>
<div>
<div>输入样例#1：</p>
<pre class="prettyprint linenums">4<br />
0 4 9 21<br />
4 0 8 17<br />
9 8 0 16<br />
21 17 16 0</pre>
</div>
<div>输出样例#1：</p>
<pre class="prettyprint linenums">28</pre>
</div>
</div>
<h2>说明</h2>
<p>题目翻译来自NOCOW。</p>
<p>USACO Training Section 3.1</p>
<h3>代码</h3>
<blockquote><div>
<pre class="prettyprint linenums"> #include&lt;iostream&gt;<br />
 #include&lt;cstring&gt;<br />
 #include&lt;cstdio&gt;<br />
 #include&lt;algorithm&gt;<br />
 #include&lt;vector&gt;<br />
 #include&lt;queue&gt;<br />
 #define MAXN 20000<br />
 using namespace std;

 struct cc{<br />
     int from,to,cost;<br />
 }e[];

 bool cmp(cc a,cc b){<br />
     return a.cost&lt;b.cost;<br />
 }

 int fa[],N,map[][],p,ans,cnt;

 int Find(int x){<br />
     if(fa[x]==x)return x;<br />
     else return fa[x]=Find(fa[x]);<br />
 }<br />
 void unite(int a,int b){<br />
     int ta=Find(a),tb=Find(b);<br />
     if(ta==tb) return;<br />
     fa[ta]=tb;<br />
 }

 int main(){<br />
 //    freopen("01.in","r",stdin);<br />
     scanf("%d",&amp;N);<br />
     for(int i=;i&lt;=N;i++){<br />
         for(int j=;j&lt;=N;j++){<br />
             scanf("%d",&amp;map[i][j]);<br />
         }<br />
     }<br />
     for(int i=;i&lt;=N;i++){<br />
         for(int j=i+;j&lt;=N;j++){<br />
             e[++p].cost=map[i][j];<br />
             e[p].from=i;<br />
             e[p].to=j;<br />
         }<br />
     }<br />
     for(int i=;i&lt;=N;i++) fa[i]=i;<br />
     sort(e+,e+p+,cmp);<br />
     for(int i=;i&lt;=p;i++){<br />
         cc x=e[i];<br />
         if(Find(x.from)==Find(x.to)) continue;<br />
         unite(x.from,x.to);<br />
         if(cnt&gt;=N-) break;<br />
         ++cnt;<br />
         ans+=x.cost;<br />
     }<br />
     printf("%d\n",ans);<br />
     return ;<br />
 }</pre>
</div></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qx2lve8.html">HttpUrlConnection</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvrmwz8.html">asp&period;net mvc js 获取model值。</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx632zq.html">Angular ngClick 阻止冒泡和默认行为</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyoeej8.html">转载：ZooKeeper Programmer&amp;&num;39&semi;s Guide（中文翻译）</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pen4z8.html">关于拉格朗日乘子法和KKT条件</a>
		</li>
						<li><a href="https://www.batexi.com/a/390levn9.html">yum命令安装mysql</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw224zq.html">Android Studio NDK 学习之接受Java传入的字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw30pl9.html">SSM框架整合总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn550z8.html">EBP与ESP寄存器的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvrkkzq.html">uva 11825</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1gngg8.html">关于JDK中的运算符和变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x6nkv8.html">org&period;springframework&period;context&period;event&period;AbstractApplicationEventMulticaster</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p5r2n8.html">老李分享： 并行计算基础&amp;amp&semi;编程模型与工具 2</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkg7lz8.html">Docker教程：dokcer machine的概念和安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g7vpzq.html">ABP框架系列之十三：&lpar;Authorization-授权&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gyy0zq.html">微信小程序动态数据跑马灯组件编写</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyym34xq.html">24 【python入门指南】class</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1ydml9.html">微信小程序开发资料汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjwkmr8.html">Spring Boot实践&mdash;&mdash;Mybatis分页插件PageHelper的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/902x2g4q.html">10件在PHP7中不要做的事情</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/3900rl49.html">EF &amp;ndash&semi; 2&period;EF数据查询基础（上）查询数据的实用编程技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96235yq.html">【jquery】幻灯片效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxj2zz9.html">WCF分布式开发必备知识&lpar;3&rpar;：Web Service 使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8opdneq.html">Bootstrap简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8opdkeq.html">【翻译十七】java-并发之高性能对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j6emlq.html">【JAVA之泛型】</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j6elgq.html">查看MYSQL中数据表占用的空间</a>
			</li>
						<li><a href="https://www.batexi.com/a/m962yvnq.html">并发异步处理队列 &period;NET 4&period;5&plus;</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8opgxpq.html">什么是好的API设计？（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/3900kyo9.html">filter应用案例一：分IP统计访问次数</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
